﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.TreeView;
using Telerik.Windows.DragDrop;
using WpfApplication1;

namespace CustomDragVisual
{
    public class CustomTreeView : RadTreeView
    {
        public CustomTreeView()
        {
            DragDropManager.AddDragInitializeHandler(this, new DragInitializeEventHandler(OnDragInitialize), true);
            DragDropManager.AddDragOverHandler(this, new Telerik.Windows.DragDrop.DragEventHandler(OnDragOver), true);
            DragDropManager.AddDropHandler(this, new Telerik.Windows.DragDrop.DragEventHandler(OnDrop), true);
        }

        public void OnDragOver(object sender, Telerik.Windows.DragDrop.DragEventArgs args)
        {
            var options = DragDropPayloadManager.GetDataFromObject(args.Data, TreeViewDragDropOptions.Key) as TreeViewDragDropOptions;
            
            var treeDragVisual = options.DragVisual as TreeViewDragVisual;

            // replace this with the text you want to display in the tooltip
            treeDragVisual.DropTarget = options.DropTargetItem.ToString();

            // override DropTargetTemplate if required
            // treeDragVisual.DropTargetTemplate = App.Current.Resources["DropTargetTemplate"] as DataTemplate;
        }

        private void OnDragInitialize(object sender, DragInitializeEventArgs args)
        {
            var treeDragVisual = args.DragVisual as TreeViewDragVisual;
            treeDragVisual.Style = App.Current.Resources["CustomDragVisual"] as Style;
        }

        public void OnDrop(object sender, Telerik.Windows.DragDrop.DragEventArgs args)
        {
            var options = DragDropPayloadManager.GetDataFromObject(args.Data, TreeViewDragDropOptions.Key) as TreeViewDragDropOptions;
            var treeDragVisual = options.DragVisual as TreeViewDragVisual;

            // handle drop as desired
        }

        protected override object CreateDragVisualContent(IList<object> draggedItems)
        {
            string dragVisualContent = "Dragging " + draggedItems.Count + " items";
            TextBlock tBlock = new TextBlock() { Text = dragVisualContent, Margin = new Thickness(5) };
            return tBlock;
        }       
    }
}
